unit main;

interface

uses
  Windows, Messages, Classes, SysUtils, Forms, Dialogs, Controls, StdCtrls,
  ComCtrls, Menus, Clipbrd, FileCtrl, ShellApi, ShlObj, ActiveX, MyUtils;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    DirectoryEdit: TEdit;
    BrowseButton: TButton;
    ExecuteButton: TButton;
    CancelButton: TButton;
    MainStatusBar: TStatusBar;
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    QuitMenu: TMenuItem;
    HelpMenu: TMenuItem;
    AboutMenu: TMenuItem;
    GoWebMenu: TMenuItem;
    ConfigMenu: TMenuItem;
    FileListMenu: TMenuItem;
    MailMenu: TMenuItem;
    N1: TMenuItem;
    procedure BrowseButtonClick(Sender: TObject);
    procedure ExecuteButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure QuitMenuClick(Sender: TObject);
    procedure AboutMenuClick(Sender: TObject);
    procedure GoWebMenuClick(Sender: TObject);
    procedure FileListMenuClick(Sender: TObject);
    procedure MailMenuClick(Sender: TObject);
  private
    Lock: Boolean;
  	procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure AppHint(Sender: TObject);
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;
  FileList: TStringList;

implementation

{$R *.DFM}

procedure ReadonlyCanceller(TopDir: TFileName);
  procedure ReadOnlyOff(FileName: TFileName);
  begin
    SetFileAttributes(PChar(FileName),
      GetFileAttributes(PChar(FileName)) and (not FILE_ATTRIBUTE_READONLY));
  end;

var
  Handle: THandle;
  Data: TWin32FindData;
  FileName: TFileName;
begin
  ReadOnlyOff(TopDir);

  Handle := Windows.FindFirstFile(PChar(TopDir + '\*.*'), Data);
  if Handle = INVALID_HANDLE_VALUE then Exit;

  FileName := TopDir + '\' + Data.cFileName;

  if not ((StrPas(Data.cFileName) = '.') or (Data.cFileName = '..')) then
  begin
    if (Data.dwFileAttributes and FILE_ATTRIBUTE_READONLY) <> 0 then
      ReadOnlyOff(FileName);

    if (Data.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
      ReadonlyCanceller(FileName);
  end;

  while FindNextFile(Handle, Data) = True do
  begin
    FileName := TopDir + '\' + Data.cFileName;

    if not ((StrPas(Data.cFileName) = '.') or (Data.cFileName = '..')) then
    begin
      if (Data.dwFileAttributes and FILE_ATTRIBUTE_READONLY) <> 0 then
        ReadOnlyOff(FileName);

      if (Data.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
        ReadonlyCanceller(FileName);
    end;
  end;

  Windows.FindClose(Handle);
end;

procedure FileListCreator(TopDir: TFileName);
var
  Handle: THandle;
  Data: TWin32FindData;
begin
  Handle := Windows.FindFirstFile(PChar(TopDir + '\*.*'), Data);
  if Handle = INVALID_HANDLE_VALUE then Exit;

  if not ((StrPas(Data.cFileName) = '.') or (StrPas(Data.cFileName) = '..')) then
  begin
    if (Data.dwFileAttributes and FILE_ATTRIBUTE_READONLY) <> 0 then
      FileList.Add(TopDir + '\' + StrPas(Data.cFileName));

    if (Data.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
      FileListCreator(TopDir + '\' + StrPas(Data.cFileName));
  end;

  while Windows.FindNextFile(Handle, Data) = True do
  begin
    if not ((StrPas(Data.cFileName) = '.') or (StrPas(Data.cFileName) = '..')) then
    begin
      if (Data.dwFileAttributes and FILE_ATTRIBUTE_READONLY) <> 0 then
        FileList.Add(TopDir + '\' + StrPas(Data.cFileName));

      if (Data.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) <> 0 then
        FileListCreator(TopDir + '\' + StrPas(Data.cFileName));
    end;
  end;

  Windows.FindClose(Handle);
end;

function SelectDirectory(Caption: string; var Directory: string): Boolean;
var
  BrowseInfo: TBrowseInfo;
  FolderName, Path: array[0..MAX_PATH] of Char;
  ItemIDList: PItemIDList;
  Allocator: IMalloc;
begin
  Result := False;

  if SHGetMalloc(Allocator) = E_FAIL then Exit;

  with BrowseInfo do
  begin
    hwndOwner := Application.Handle;
    pidlRoot := nil;
    pszDisplayName := FolderName;
    lpszTitle := PChar(Caption);
    ulFlags := BIF_RETURNONLYFSDIRS;
    lpfn := nil;
  end;

  ItemIDList := SHBrowseForFolder(BrowseInfo);
  if ItemIDList = nil then Exit;

  SHGetPathFromIDList(ItemIDList, Path);
  Directory := StrPas(Path);

  Allocator.Free(ItemIDList);

  Result := True;
end;


{TMainForm}

procedure TMainForm.BrowseButtonClick(Sender: TObject);
var
  Directory: string;
begin
  Directory := DirectoryEdit.Text;
  if SelectDirectory('gbvfBNg̑I', Directory) then
    DirectoryEdit.Text := Directory;
end;

procedure TMainForm.ExecuteButtonClick(Sender: TObject);
var
  C: TClipboard;
begin
  if not DirectoryExists(DirectoryEdit.Text) then
  begin
    ShowMessage('w肵fBNg݂͑܂: ' + DirectoryEdit.Text);
    Exit;
  end;

  if Lock = True then
  begin
    ShowMessage('ݏł');
  end;

  Lock := True;
  MainStatusBar.SimpleText := 'ł...';

  if not FileListMenu.Checked then ReadonlyCanceller(DirectoryEdit.Text)
  else
  begin
    FileList := TStringList.Create;
    FileListCreator(DirectoryEdit.Text);
    C := Clipboard;
    C.AsText := FileList.Text;
    FileList.Free;
  end;

  Lock := False;
  MainStatusBar.SimpleText := '܂';
end;

procedure TMainForm.CancelButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Lock := False;
	DragAcceptFiles(MainForm.Handle, True);
  if ParamCount > 0 then DirectoryEdit.Text := ParamStr(1);
  Application.OnHint := AppHint;
end;

procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
  FileName: array[0..MAX_PATH] of Char;
begin
  DragQueryFile(Msg.Drop, 0, FileName, MAX_PATH + 1);
  DirectoryEdit.Text := StrPas(FileName);
  DragFinish(Msg.Drop);
end;

procedure TMainForm.QuitMenuClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.AboutMenuClick(Sender: TObject);
begin
  AboutBox;
end;

procedure TMainForm.GoWebMenuClick(Sender: TObject);
begin
  GoWeb;
end;

procedure TMainForm.FileListMenuClick(Sender: TObject);
begin
  FileListMenu.Checked := not FileListMenu.Checked;
end;

procedure TMainForm.MailMenuClick(Sender: TObject);
begin
  SendMail;
end;

procedure TMainForm.AppHint(Sender: TObject);
begin
  MainStatusBar.SimpleText := Application.Hint;
end;

end.
